import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Beispielgerst fr eine mit Profiling-Code
 * ausgestattete Klasse
 *
 * @author Michael Tamm
 */
public class Foo {
    /** Der normale Logger. */
    private static final Logger LOGGER =
        Logger.getLogger(Foo.class.getName());

    /** Der Logger fr Profiling-Mitteilungen. */
    private static final Logger PROFILING_LOGGER =
        Logger.getLogger("Profiling");

    /** Mit Profiling-Code ausgestattete Methode. */
    public void f() {
        boolean _profiling = PROFILING_LOGGER.isLoggable(Level.INFO);
        long _startTime = 0;
        if (_profiling) {
            _startTime = System.currentTimeMillis();
        }
        try {
            // ... der eigentliche Code ...
        } finally {
            if (_profiling) {
                long dt = System.currentTimeMillis() - _startTime;
                PROFILING_LOGGER.info("f() dauerte " + dt + " ms.");
            }
        }
    }
}
