/**
 * Fgt Profiling-Code zu beliebigen Methoden hinzu.
 *
 * @author Michael Tamm
 */
public aspect Profiling {
    pointcut anyPublicVoidMethod(): execution(public void *.*(..));
    pointcut anyPublicIntMethod(): execution(public int *.*(..));

    void around(): anyPublicVoidMethod() {
        long startTime = System.currentTimeMillis();
        try {
            proceed();
        } finally {
            long dt = System.currentTimeMillis() - startTime;
            System.out.println(thisJoinPointStaticPart.getSignature() + " dauerte " + dt + " ms.");
        }
    }

    int around(): anyPublicIntMethod() {
        long startTime = System.currentTimeMillis();
        try {
            return proceed();
        } finally {
            long dt = System.currentTimeMillis() - startTime;
            System.out.println(thisJoinPointStaticPart.getSignature() + " dauerte " + dt + " ms.");
        }
    }
}
