<isol>>
#include <jvmpi.h>

//
// Global JVMPI_interface pointer ...
//
static JVMPI_Interface* jvmpi_interface = 0;

extern "C" {

  //
  // Profiler agent entry point ...
  //
  JNIEXPORT jint JNICALL JVM_OnLoad(JavaVM* jvm, 
                           char*, void*) {
    // Get JVMPI interface pointer ...
    if ((jvm->GetEnv((void**) &jvmpi_interface, 
           JVMPI_VERSION_1)) < 0) {
      return JNI_ERR;
    }
    return JNI_OK;
  }

  //
  // Native function iXprof.getCurrentThreadCpuTime,
  // which exposes the JVMPI function GetCurrentThreadCpuTime ...
  //
  JNIEXPORT jlong JNICALL 
     Java_iXprof_getCurrentThreadCpuTime(JNIEnv*, jclass) {
    // Return -1 if profiling agent not initialized ...
    if (jvmpi_interface == 0) {
      return -1;
    }
    // Return CPU time of current thread in nanoseconds ...
    return jvmpi_interface->GetCurrentThreadCpuTime();
  }

}
